- Qt 5.15
- Qt 3D
- C++ Classes
- QDiffuseSpecularMaterial
- Qt 5.15.11 Reference Documentation

# QDiffuseSpecularMaterial Class

class Qt3DExtras::QDiffuseSpecularMaterial

The QDiffuseSpecularMaterial class provides a default implementation of the phong lighting effect. More...

Header: | #include <QDiffuseSpecularMaterial>
qmake: | QT += 3dextras
Since: | Qt 5.10
Instantiated By: | DiffuseSpecularMaterial
Inherits: | Qt3DRender::QMaterial

This class was introduced in Qt 5.10.

- List of all members, including inherited members

## Properties

- alphaBlending : bool
- ambient : QColor
- diffuse : QVariant
- normal : QVariant

- shininess : float
- specular : QVariant
- textureScale : float

## Public Functions

virtual | ~QDiffuseSpecularMaterial()
QColor | ambient() const
QVariant | diffuse() const
bool | isAlphaBlendingEnabled() const
QVariant | normal() const
float | shininess() const
QVariant | specular() const
float | textureScale() const

## Public Slots

void | setAlphaBlendingEnabled(bool enabled)
void | setAmbient(const QColor &ambient)
void | setDiffuse(const QVariant &diffuse)
void | setNormal(const QVariant &normal)
void | setShininess(float shininess)
void | setSpecular(const QVariant &specular)
void | setTextureScale(float textureScale)

## Signals

void | alphaBlendingEnabledChanged(bool enabled)
void | ambientChanged(const QColor &ambient)
void | diffuseChanged(const QVariant &diffuse)
void | normalChanged(const QVariant &normal)
void | shininessChanged(float shininess)
void | specularChanged(const QVariant &specular)
void | textureScaleChanged(float textureScale)

## Detailed Description

The phong lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components are controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### alphaBlending : bool

Indicates if the alpha information coming from the diffuse property will be taken into account during rendering. Defaults to false.

Access functions:

bool | isAlphaBlendingEnabled() const
void | setAlphaBlendingEnabled(bool enabled)

Notifier signal:

void | alphaBlendingEnabledChanged(bool enabled)

### ambient : QColor

Holds the ambient color that is emitted by an object without any other light source.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : QVariant

Holds the diffuse color of the material that is emitted for rough surface reflections with the lights. This can be either a plain color value or a texture.

Access functions:

QVariant | diffuse() const
void | setDiffuse(const QVariant &diffuse)

Notifier signal:

void | diffuseChanged(const QVariant &diffuse)

### normal : QVariant

Holds the current normal map texture of the material. This can only be a texture, otherwise it is ignored. By default this map is not set.

Access functions:

QVariant | normal() const
void | setNormal(const QVariant &normal)

Notifier signal:

void | normalChanged(const QVariant &normal)

### shininess : float

Holds the shininess exponent. Higher values of shininess result in a smaller and brighter highlight.

Defaults to 150.0.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QVariant

Holds the specular color of the material that is emitted for shiny surface reflections with the lights. This can be either a plain color value or a texture.

Access functions:

QVariant | specular() const
void | setSpecular(const QVariant &specular)

Notifier signal:

void | specularChanged(const QVariant &specular)

### textureScale : float

Holds the current texture scale. It is applied as a multiplier to texture coordinates at render time. Defaults to 1.0.

When used in conjunction with QTextureWrapMode::Repeat, textureScale provides a simple way to tile a texture across a surface. For example, a texture scale of `4.0` would result in 16 (4x4) tiles.

Access functions:

float | textureScale() const
void | setTextureScale(float textureScale)

Notifier signal:

void | textureScaleChanged(float textureScale)

## Member Function Documentation

### `[virtual]` QDiffuseSpecularMaterial::~QDiffuseSpecularMaterial()

Destroys the QDiffuseSpecularMaterial.